From 39951a9d220ddb277f2d281fb404aa0a066cea7e Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Wed, 10 Jul 2013 14:55:31 -0400
Subject: [PATCH] Reorganized server files.

Some server files in base/common have been moved to base/server for
consistency. The build scripts have been updated accordingly.
---
 base/common/CMakeLists.txt                         | 38 ----------------------
 base/server/CMakeLists.txt                         | 35 ++++++++++++++++++++
 base/{common => server}/setup/CertServer.directory |  0
 base/{common => server}/setup/menu.xml             |  0
 base/{common => server}/setup/pkidaemon_registry   |  0
 base/{common => server}/setup/web-app_2_3.dtd      |  0
 .../shared => server/share}/conf/catalina.policy   |  0
 .../share}/conf/catalina.properties                |  0
 .../shared => server/share}/conf/context.xml       |  0
 .../shared => server/share}/conf/custom.policy     |  0
 .../shared => server/share}/conf/log4j.properties  |  0
 .../share}/conf/logging.properties                 |  0
 .../shared => server/share}/conf/pki.policy        |  0
 .../shared => server/share}/conf/server.xml        |  0
 .../share}/conf/serverCertNick.conf                |  0
 .../shared => server/share}/conf/tomcat-users.xml  |  0
 .../shared => server/share}/conf/tomcat.conf       |  0
 base/{common/shared => server/share}/conf/web.xml  |  0
 .../share}/lib/systemd/system/pki-tomcatd.target   |  0
 .../share}/lib/systemd/system/pki-tomcatd@.service |  0
 .../share}/webapps/ROOT/META-INF/context.xml       |  0
 .../share}/webapps/ROOT/WEB-INF/web.xml            |  0
 .../shared => server/share}/webapps/ROOT/index.jsp |  0
 .../share}/webapps/pki/META-INF/context.xml        |  0
 .../admin/console/config/adminauthenticatepanel.vm |  0
 .../webapps/pki/admin/console/config/adminpanel.vm |  0
 .../admin/console/config/agentauthenticatepanel.vm |  0
 .../pki/admin/console/config/backupkeycertpanel.vm |  0
 .../pki/admin/console/config/certchainpanel.vm     |  0
 .../admin/console/config/certprettyprintpanel.vm   |  0
 .../pki/admin/console/config/certrequestpanel.vm   |  0
 .../pki/admin/console/config/config_addhsm.vm      |  0
 .../admin/console/config/config_hsmloginpanel.vm   |  0
 .../admin/console/config/createsubsystempanel.vm   |  0
 .../pki/admin/console/config/databasepanel.vm      |  0
 .../admin/console/config/displaycertchainpanel.vm  |  0
 .../webapps/pki/admin/console/config/donepanel.vm  |  0
 .../webapps/pki/admin/console/config/footer.vm     |  0
 .../webapps/pki/admin/console/config/header.vm     |  0
 .../pki/admin/console/config/hierarchypanel.vm     |  0
 .../admin/console/config/importadmincertpanel.vm   |  0
 .../pki/admin/console/config/importcachainpanel.vm |  0
 .../webapps/pki/admin/console/config/login.vm      |  0
 .../pki/admin/console/config/modulepanel.vm        |  0
 .../webapps/pki/admin/console/config/namepanel.vm  |  0
 .../admin/console/config/restorekeycertpanel.vm    |  0
 .../pki/admin/console/config/savepkcs12panel.vm    |  0
 .../console/config/securitydomainloginpanel.vm     |  0
 .../admin/console/config/securitydomainpanel.vm    |  0
 .../webapps/pki/admin/console/config/sidemenu.vm   |  0
 .../webapps/pki/admin/console/config/sizepanel.vm  |  0
 .../webapps/pki/admin/console/config/topmenu.vm    |  0
 .../pki/admin/console/config/welcomepanel.vm       |  0
 .../webapps/pki/admin/console/config/wizard.vm     |  0
 .../share}/webapps/pki/admin/console/config/xml.vm |  0
 .../share}/webapps/pki/admin/console/js/misc.js    |  0
 .../share}/webapps/pki/js/jquery-min.js            |  0
 .../webapps/pki/js/jquery.i18n.properties-min.js   |  0
 58 files changed, 35 insertions(+), 38 deletions(-)
 rename base/{common => server}/setup/CertServer.directory (100%)
 rename base/{common => server}/setup/menu.xml (100%)
 rename base/{common => server}/setup/pkidaemon_registry (100%)
 rename base/{common => server}/setup/web-app_2_3.dtd (100%)
 rename base/{common/shared => server/share}/conf/catalina.policy (100%)
 rename base/{common/shared => server/share}/conf/catalina.properties (100%)
 rename base/{common/shared => server/share}/conf/context.xml (100%)
 rename base/{common/shared => server/share}/conf/custom.policy (100%)
 rename base/{common/shared => server/share}/conf/log4j.properties (100%)
 rename base/{common/shared => server/share}/conf/logging.properties (100%)
 rename base/{common/shared => server/share}/conf/pki.policy (100%)
 rename base/{common/shared => server/share}/conf/server.xml (100%)
 rename base/{common/shared => server/share}/conf/serverCertNick.conf (100%)
 rename base/{common/shared => server/share}/conf/tomcat-users.xml (100%)
 rename base/{common/shared => server/share}/conf/tomcat.conf (100%)
 rename base/{common/shared => server/share}/conf/web.xml (100%)
 rename base/{common/shared => server/share}/lib/systemd/system/pki-tomcatd.target (100%)
 rename base/{common/shared => server/share}/lib/systemd/system/pki-tomcatd@.service (100%)
 rename base/{common/shared => server/share}/webapps/ROOT/META-INF/context.xml (100%)
 rename base/{common/shared => server/share}/webapps/ROOT/WEB-INF/web.xml (100%)
 rename base/{common/shared => server/share}/webapps/ROOT/index.jsp (100%)
 rename base/{common/shared => server/share}/webapps/pki/META-INF/context.xml (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/adminauthenticatepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/adminpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/agentauthenticatepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/backupkeycertpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/certchainpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/certprettyprintpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/certrequestpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/config_addhsm.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/config_hsmloginpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/createsubsystempanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/databasepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/displaycertchainpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/donepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/footer.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/header.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/hierarchypanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/importadmincertpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/importcachainpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/login.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/modulepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/namepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/restorekeycertpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/savepkcs12panel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/securitydomainloginpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/securitydomainpanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/sidemenu.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/sizepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/topmenu.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/welcomepanel.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/wizard.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/config/xml.vm (100%)
 rename base/{common/shared => server/share}/webapps/pki/admin/console/js/misc.js (100%)
 rename base/{common/shared => server/share}/webapps/pki/js/jquery-min.js (100%)
 rename base/{common/shared => server/share}/webapps/pki/js/jquery.i18n.properties-min.js (100%)

diff --git a/base/common/CMakeLists.txt b/base/common/CMakeLists.txt
index 3798503c06c9fa44df1354f4e0654e34964bd670..e2b2a2f151a678d02e2e23862c27c5745efa548a 100644
--- a/base/common/CMakeLists.txt
+++ b/base/common/CMakeLists.txt
@@ -33,32 +33,6 @@ install(
         ${PYTHON_SITE_PACKAGES}
 )
 
-# install systemd scripts
-install(
-    FILES
-        shared/lib/systemd/system/pki-tomcatd.target
-        shared/lib/systemd/system/pki-tomcatd@.service
-    DESTINATION
-        ${SYSTEMD_LIB_INSTALL_DIR}
-    PERMISSIONS
-        OWNER_EXECUTE OWNER_WRITE OWNER_READ
-        GROUP_EXECUTE GROUP_READ
-        WORLD_EXECUTE WORLD_READ
-)
-
-install(
-    FILES
-        setup/CertServer.directory
-        setup/menu.xml
-        setup/pkidaemon_registry
-    DESTINATION
-        ${DATA_INSTALL_DIR}/setup/
-    PERMISSIONS
-        OWNER_WRITE OWNER_READ
-        GROUP_READ
-        WORLD_READ
-)
-
 # install executables
 install(
     FILES
@@ -71,18 +45,6 @@ install(
         WORLD_EXECUTE WORLD_READ
 )
 
-# install server files
-# TODO: move into base/server
-install(
-    DIRECTORY
-        shared/
-    DESTINATION
-        ${DATA_INSTALL_DIR}/server/
-    PATTERN
-        "lib/*" EXCLUDE
-)
-
-
 install(
     DIRECTORY
         upgrade
diff --git a/base/server/CMakeLists.txt b/base/server/CMakeLists.txt
index 8beedbb67aae865522105633d305d5e6f9a85f3e..89fa033a82de0e27c6886de0c3e5b51b14991534 100644
--- a/base/server/CMakeLists.txt
+++ b/base/server/CMakeLists.txt
@@ -52,6 +52,31 @@ install(
         ${PYTHON_SITE_PACKAGES}
 )
 
+# install systemd scripts
+install(
+    DIRECTORY
+        share/lib/systemd/system/
+    DESTINATION
+        ${SYSTEMD_LIB_INSTALL_DIR}
+    FILE_PERMISSIONS
+        OWNER_EXECUTE OWNER_WRITE OWNER_READ
+        GROUP_EXECUTE GROUP_READ
+        WORLD_EXECUTE WORLD_READ
+)
+
+install(
+    FILES
+        setup/CertServer.directory
+        setup/menu.xml
+        setup/pkidaemon_registry
+    DESTINATION
+        ${DATA_INSTALL_DIR}/setup/
+    PERMISSIONS
+        OWNER_WRITE OWNER_READ
+        GROUP_READ
+        WORLD_READ
+)
+
 # install executables
 install(
     FILES
@@ -117,6 +142,16 @@ install(
         ${DATA_INSTALL_DIR}/deployment
 )
 
+# install server files
+install(
+    DIRECTORY
+        share/
+    DESTINATION
+        ${DATA_INSTALL_DIR}/server/
+    PATTERN
+        "lib/*" EXCLUDE
+)
+
 # install server configuration files
 install(
     DIRECTORY
diff --git a/base/common/setup/CertServer.directory b/base/server/setup/CertServer.directory
similarity index 100%
rename from base/common/setup/CertServer.directory
rename to base/server/setup/CertServer.directory
diff --git a/base/common/setup/menu.xml b/base/server/setup/menu.xml
similarity index 100%
rename from base/common/setup/menu.xml
rename to base/server/setup/menu.xml
diff --git a/base/common/setup/pkidaemon_registry b/base/server/setup/pkidaemon_registry
similarity index 100%
rename from base/common/setup/pkidaemon_registry
rename to base/server/setup/pkidaemon_registry
diff --git a/base/common/setup/web-app_2_3.dtd b/base/server/setup/web-app_2_3.dtd
similarity index 100%
rename from base/common/setup/web-app_2_3.dtd
rename to base/server/setup/web-app_2_3.dtd
diff --git a/base/common/shared/conf/catalina.policy b/base/server/share/conf/catalina.policy
similarity index 100%
rename from base/common/shared/conf/catalina.policy
rename to base/server/share/conf/catalina.policy
diff --git a/base/common/shared/conf/catalina.properties b/base/server/share/conf/catalina.properties
similarity index 100%
rename from base/common/shared/conf/catalina.properties
rename to base/server/share/conf/catalina.properties
diff --git a/base/common/shared/conf/context.xml b/base/server/share/conf/context.xml
similarity index 100%
rename from base/common/shared/conf/context.xml
rename to base/server/share/conf/context.xml
diff --git a/base/common/shared/conf/custom.policy b/base/server/share/conf/custom.policy
similarity index 100%
rename from base/common/shared/conf/custom.policy
rename to base/server/share/conf/custom.policy
diff --git a/base/common/shared/conf/log4j.properties b/base/server/share/conf/log4j.properties
similarity index 100%
rename from base/common/shared/conf/log4j.properties
rename to base/server/share/conf/log4j.properties
diff --git a/base/common/shared/conf/logging.properties b/base/server/share/conf/logging.properties
similarity index 100%
rename from base/common/shared/conf/logging.properties
rename to base/server/share/conf/logging.properties
diff --git a/base/common/shared/conf/pki.policy b/base/server/share/conf/pki.policy
similarity index 100%
rename from base/common/shared/conf/pki.policy
rename to base/server/share/conf/pki.policy
diff --git a/base/common/shared/conf/server.xml b/base/server/share/conf/server.xml
similarity index 100%
rename from base/common/shared/conf/server.xml
rename to base/server/share/conf/server.xml
diff --git a/base/common/shared/conf/serverCertNick.conf b/base/server/share/conf/serverCertNick.conf
similarity index 100%
rename from base/common/shared/conf/serverCertNick.conf
rename to base/server/share/conf/serverCertNick.conf
diff --git a/base/common/shared/conf/tomcat-users.xml b/base/server/share/conf/tomcat-users.xml
similarity index 100%
rename from base/common/shared/conf/tomcat-users.xml
rename to base/server/share/conf/tomcat-users.xml
diff --git a/base/common/shared/conf/tomcat.conf b/base/server/share/conf/tomcat.conf
similarity index 100%
rename from base/common/shared/conf/tomcat.conf
rename to base/server/share/conf/tomcat.conf
diff --git a/base/common/shared/conf/web.xml b/base/server/share/conf/web.xml
similarity index 100%
rename from base/common/shared/conf/web.xml
rename to base/server/share/conf/web.xml
diff --git a/base/common/shared/lib/systemd/system/pki-tomcatd.target b/base/server/share/lib/systemd/system/pki-tomcatd.target
similarity index 100%
rename from base/common/shared/lib/systemd/system/pki-tomcatd.target
rename to base/server/share/lib/systemd/system/pki-tomcatd.target
diff --git a/base/common/shared/lib/systemd/system/pki-tomcatd@.service b/base/server/share/lib/systemd/system/pki-tomcatd@.service
similarity index 100%
rename from base/common/shared/lib/systemd/system/pki-tomcatd@.service
rename to base/server/share/lib/systemd/system/pki-tomcatd@.service
diff --git a/base/common/shared/webapps/ROOT/META-INF/context.xml b/base/server/share/webapps/ROOT/META-INF/context.xml
similarity index 100%
rename from base/common/shared/webapps/ROOT/META-INF/context.xml
rename to base/server/share/webapps/ROOT/META-INF/context.xml
diff --git a/base/common/shared/webapps/ROOT/WEB-INF/web.xml b/base/server/share/webapps/ROOT/WEB-INF/web.xml
similarity index 100%
rename from base/common/shared/webapps/ROOT/WEB-INF/web.xml
rename to base/server/share/webapps/ROOT/WEB-INF/web.xml
diff --git a/base/common/shared/webapps/ROOT/index.jsp b/base/server/share/webapps/ROOT/index.jsp
similarity index 100%
rename from base/common/shared/webapps/ROOT/index.jsp
rename to base/server/share/webapps/ROOT/index.jsp
diff --git a/base/common/shared/webapps/pki/META-INF/context.xml b/base/server/share/webapps/pki/META-INF/context.xml
similarity index 100%
rename from base/common/shared/webapps/pki/META-INF/context.xml
rename to base/server/share/webapps/pki/META-INF/context.xml
diff --git a/base/common/shared/webapps/pki/admin/console/config/adminauthenticatepanel.vm b/base/server/share/webapps/pki/admin/console/config/adminauthenticatepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/adminauthenticatepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/adminauthenticatepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/adminpanel.vm b/base/server/share/webapps/pki/admin/console/config/adminpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/adminpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/adminpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/agentauthenticatepanel.vm b/base/server/share/webapps/pki/admin/console/config/agentauthenticatepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/agentauthenticatepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/agentauthenticatepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/backupkeycertpanel.vm b/base/server/share/webapps/pki/admin/console/config/backupkeycertpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/backupkeycertpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/backupkeycertpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/certchainpanel.vm b/base/server/share/webapps/pki/admin/console/config/certchainpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/certchainpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/certchainpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/certprettyprintpanel.vm b/base/server/share/webapps/pki/admin/console/config/certprettyprintpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/certprettyprintpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/certprettyprintpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/certrequestpanel.vm b/base/server/share/webapps/pki/admin/console/config/certrequestpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/certrequestpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/certrequestpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/config_addhsm.vm b/base/server/share/webapps/pki/admin/console/config/config_addhsm.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/config_addhsm.vm
rename to base/server/share/webapps/pki/admin/console/config/config_addhsm.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/config_hsmloginpanel.vm b/base/server/share/webapps/pki/admin/console/config/config_hsmloginpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/config_hsmloginpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/config_hsmloginpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/createsubsystempanel.vm b/base/server/share/webapps/pki/admin/console/config/createsubsystempanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/createsubsystempanel.vm
rename to base/server/share/webapps/pki/admin/console/config/createsubsystempanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/databasepanel.vm b/base/server/share/webapps/pki/admin/console/config/databasepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/databasepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/databasepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/displaycertchainpanel.vm b/base/server/share/webapps/pki/admin/console/config/displaycertchainpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/displaycertchainpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/displaycertchainpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/donepanel.vm b/base/server/share/webapps/pki/admin/console/config/donepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/donepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/donepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/footer.vm b/base/server/share/webapps/pki/admin/console/config/footer.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/footer.vm
rename to base/server/share/webapps/pki/admin/console/config/footer.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/header.vm b/base/server/share/webapps/pki/admin/console/config/header.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/header.vm
rename to base/server/share/webapps/pki/admin/console/config/header.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/hierarchypanel.vm b/base/server/share/webapps/pki/admin/console/config/hierarchypanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/hierarchypanel.vm
rename to base/server/share/webapps/pki/admin/console/config/hierarchypanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/importadmincertpanel.vm b/base/server/share/webapps/pki/admin/console/config/importadmincertpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/importadmincertpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/importadmincertpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/importcachainpanel.vm b/base/server/share/webapps/pki/admin/console/config/importcachainpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/importcachainpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/importcachainpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/login.vm b/base/server/share/webapps/pki/admin/console/config/login.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/login.vm
rename to base/server/share/webapps/pki/admin/console/config/login.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/modulepanel.vm b/base/server/share/webapps/pki/admin/console/config/modulepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/modulepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/modulepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/namepanel.vm b/base/server/share/webapps/pki/admin/console/config/namepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/namepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/namepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/restorekeycertpanel.vm b/base/server/share/webapps/pki/admin/console/config/restorekeycertpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/restorekeycertpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/restorekeycertpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/savepkcs12panel.vm b/base/server/share/webapps/pki/admin/console/config/savepkcs12panel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/savepkcs12panel.vm
rename to base/server/share/webapps/pki/admin/console/config/savepkcs12panel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/securitydomainloginpanel.vm b/base/server/share/webapps/pki/admin/console/config/securitydomainloginpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/securitydomainloginpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/securitydomainloginpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/securitydomainpanel.vm b/base/server/share/webapps/pki/admin/console/config/securitydomainpanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/securitydomainpanel.vm
rename to base/server/share/webapps/pki/admin/console/config/securitydomainpanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/sidemenu.vm b/base/server/share/webapps/pki/admin/console/config/sidemenu.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/sidemenu.vm
rename to base/server/share/webapps/pki/admin/console/config/sidemenu.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/sizepanel.vm b/base/server/share/webapps/pki/admin/console/config/sizepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/sizepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/sizepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/topmenu.vm b/base/server/share/webapps/pki/admin/console/config/topmenu.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/topmenu.vm
rename to base/server/share/webapps/pki/admin/console/config/topmenu.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/welcomepanel.vm b/base/server/share/webapps/pki/admin/console/config/welcomepanel.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/welcomepanel.vm
rename to base/server/share/webapps/pki/admin/console/config/welcomepanel.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/wizard.vm b/base/server/share/webapps/pki/admin/console/config/wizard.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/wizard.vm
rename to base/server/share/webapps/pki/admin/console/config/wizard.vm
diff --git a/base/common/shared/webapps/pki/admin/console/config/xml.vm b/base/server/share/webapps/pki/admin/console/config/xml.vm
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/config/xml.vm
rename to base/server/share/webapps/pki/admin/console/config/xml.vm
diff --git a/base/common/shared/webapps/pki/admin/console/js/misc.js b/base/server/share/webapps/pki/admin/console/js/misc.js
similarity index 100%
rename from base/common/shared/webapps/pki/admin/console/js/misc.js
rename to base/server/share/webapps/pki/admin/console/js/misc.js
diff --git a/base/common/shared/webapps/pki/js/jquery-min.js b/base/server/share/webapps/pki/js/jquery-min.js
similarity index 100%
rename from base/common/shared/webapps/pki/js/jquery-min.js
rename to base/server/share/webapps/pki/js/jquery-min.js
diff --git a/base/common/shared/webapps/pki/js/jquery.i18n.properties-min.js b/base/server/share/webapps/pki/js/jquery.i18n.properties-min.js
similarity index 100%
rename from base/common/shared/webapps/pki/js/jquery.i18n.properties-min.js
rename to base/server/share/webapps/pki/js/jquery.i18n.properties-min.js
-- 
1.8.1.4